cryptonite-0.9: Cryptography Primitives sink

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | unknown
Safe Haskell | None
Language | Haskell2010

Crypto.PubKey.Ed25519

Contents

- Smart constructors
- methods

Description

Ed25519 support

Synopsis

- data SecretKey
- data PublicKey
- data Signature
- signature :: ByteArrayAccess ba => ba -> CryptoFailable Signature
- publicKey :: ByteArrayAccess ba => ba -> CryptoFailable PublicKey
- secretKey :: ByteArrayAccess ba => ba -> CryptoFailable SecretKey
- toPublic :: SecretKey -> PublicKey
- sign :: ByteArrayAccess ba => SecretKey -> PublicKey -> ba -> Signature
- verify :: ByteArrayAccess ba => PublicKey -> ba -> Signature -> Bool

# Documentation

data SecretKey

An Ed25519 Secret key

Instances

Eq SecretKey |
NFData SecretKey |
ByteArrayAccess SecretKey |

data PublicKey

An Ed25519 public key

Instances

Eq PublicKey |
Show PublicKey |
NFData PublicKey |
ByteArrayAccess PublicKey |

data Signature

An Ed25519 signature

Instances

Eq Signature |
Show Signature |
NFData Signature |
ByteArrayAccess Signature |

# Smart constructors

signature :: ByteArrayAccess ba => ba -> CryptoFailable Signature

Try to build a signature from a bytearray

publicKey :: ByteArrayAccess ba => ba -> CryptoFailable PublicKey

Try to build a public key from a bytearray

secretKey :: ByteArrayAccess ba => ba -> CryptoFailable SecretKey

Try to build a secret key from a bytearray

# methods

toPublic :: SecretKey -> PublicKey

Create a public key from a secret key

sign :: ByteArrayAccess ba => SecretKey -> PublicKey -> ba -> Signature

Sign a message using the key pair

verify :: ByteArrayAccess ba => PublicKey -> ba -> Signature -> Bool

Verify a message